#include <inttypes.h>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <string.h>

uint64_t h(char *key, int length) {
	uint64_t state = 0x0123456789abcdef;
	for(int i = 0; i < length; i++) {
		state += *(key + i);
		state ^= 0xbadc0de;
		state = (state >> 30) | (state << 34);
		state -= *(key + i);
		state *= 3;
	}
	return state;
}

uint64_t h2(uint64_t key) {
	char cur;
	uint64_t state = 0x0123456789abcdef;
	while(key != 0) {
		cur = (char) key % 256;
		key >>= 8;
		state += cur;
		state ^= 0xbadc0de;
		state = (state >> 30) | (state << 34);
		state -= cur;
		state *= 3;
	}
	return state;
}

int main() {
	uint64_t input = ((uint64_t) rand()) << 16 ^ rand();
	//printf("%lu\n", input);
	printf("%lu\n", h2(input));
	return 0;
}
